using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WatchDog
{
    public partial class Form1 : Form
    {
        const int WD_TYPE = 1; //PAC_WDT_OS
        const uint WatchDogTime = 10;

        uint SecondsLeft = WatchDogTime;

        public Form1()
        {
            InitializeComponent();
            timer1.Interval = 1000;
        }

        private void button1_Click(object sender, EventArgs e)  //Enable
        {
            PACNET.Sys.WDT.EnableWatchDog(WD_TYPE, WatchDogTime);
            SecondsLeft = WatchDogTime;
             timer1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)  //Disable
        {
            PACNET.Sys.WDT.DisableWatchDog(WD_TYPE);
            timer1.Enabled = false;
            label1.Text = "X";
        }

        private void button3_Click(object sender, EventArgs e)  //Refresh
        {
            PACNET.Sys.WDT.RefreshWatchDog(WD_TYPE);
            SecondsLeft = WatchDogTime;
        }

        private void timer1_Tick(object sender, EventArgs e)  //used for count-down
        {
            
           
                label1.Text = SecondsLeft.ToString();
                SecondsLeft--;
                
        }


    }
}