Imports System.Threading

Public Class Form1
    Private lbArr(9) As Label
    Private tbArr(9) As TextBox

    Public Sub New()
        InitializeComponent()

        For i As Integer = 0 To 9
            lbArr(i) = New Label()
            tbArr(i) = New TextBox()
            Me.Controls.Add(lbArr(i))
            Me.Controls.Add(tbArr(i))
        Next i
    End Sub
    Private Sub addItems2cbbSingleCh(ByVal total_ch As Integer)
        cbbSingleCh.Items.Clear()
        For i As Integer = 0 To total_ch - 1
            cbbSingleCh.Items.Add(i)
        Next i
    End Sub

    Private Sub printTextBoxs(ByVal channel As Integer)
        Dim x As Integer = 20
        Dim y As Integer = 225

        For i As Integer = 0 To channel - 1
            'label locations:
            lbArr(i).Location = New Point(x + 120 * (i Mod 5), y + 40 * (i \ 5))
            lbArr(i).Size = New Size(50, 20)
            lbArr(i).Text = "CH_" & i.ToString("00")
            lbArr(i).Visible = True
        Next i
        For i As Integer = 0 To channel - 1
            'textbox locations:
            x = 75
            y = 225
            tbArr(i).Location = New Point(x + 120 * (i Mod 5), y + 40 * (i \ 5))
            tbArr(i).Size = New Size(60, 25)
            tbArr(i).Text = ""
            tbArr(i).Visible = True
        Next i

        For j As Integer = channel To 9
            lbArr(j).Visible = False
            tbArr(j).Visible = False
        Next j
    End Sub
    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim slot As Integer = cbbSlot.SelectedIndex + 1
        Dim total_ch As Integer = Integer.Parse(cbbChannel.Items(cbbChannel.SelectedIndex).ToString())
        Dim ch As Integer = Integer.Parse(cbbSingleCh.Items(cbbSingleCh.SelectedIndex).ToString())
        Dim AI_fValue As Single = 0
        Dim AI_hValue As Integer = 0

        Dim h As IntPtr = PACNET.UART.Open("")

        If radioButton1.Checked Then
            PACNET.PAC_IO.ReadAI(h, slot, ch, total_ch, AI_fValue)
            Thread.Sleep(10)
            textBox1.Text = AI_fValue.ToString()
        Else
            PACNET.PAC_IO.ReadAIHex(h, slot, ch, total_ch, AI_hValue)
            Thread.Sleep(10)
            textBox1.Text = AI_hValue.ToString("X")
        End If

        PACNET.UART.Close(h)
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        Dim slot As Integer = cbbSlot.SelectedIndex + 1
        Dim total_ch As Integer = Integer.Parse(cbbChannel.Items(cbbChannel.SelectedIndex).ToString())

        Dim AI_fArr(9) As Single
        Dim AI_hArr(9) As Integer

        Dim h As IntPtr = PACNET.UART.Open("")

        If radioButton1.Checked Then
            PACNET.PAC_IO.ReadAIAll(h, slot, AI_fArr)
            For i As Integer = 0 To total_ch - 1
                tbArr(i).Text = AI_fArr(i).ToString()
            Next i
        Else
            PACNET.PAC_IO.ReadAIAllHex(h, slot, AI_hArr)
            For i As Integer = 0 To total_ch - 1
                tbArr(i).Text = AI_hArr(i).ToString("X")
            Next i
        End If

        PACNET.UART.Close(h)
    End Sub

    Private Sub cbbChannel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbbChannel.SelectedIndexChanged
        Dim total_ch As Integer = Integer.Parse(cbbChannel.Items(cbbChannel.SelectedIndex).ToString())

        printTextBoxs(total_ch)
        addItems2cbbSingleCh(total_ch)
        cbbSingleCh.SelectedIndex = 0
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbbSlot.SelectedIndex = 0
        cbbChannel.SelectedIndex = 0
        radioButton1.Checked = True 'float, engineering format

        Dim total_ch As Integer = Integer.Parse(cbbChannel.Items(cbbChannel.SelectedIndex).ToString())

        addItems2cbbSingleCh(total_ch)
        cbbSingleCh.SelectedIndex = 0
        printTextBoxs(total_ch)
    End Sub
End Class
