Public Class Form1
    Dim hPort As IntPtr
    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        hPort = PACNET.UART.Open("")
        If (hPort = -1) Then
            Dim ErrorCode As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show("open port error, error code " + Convert.ToString(ErrorCode))
        Else
            btnClose.Enabled = True
            btnOpen.Enabled = False
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        PACNET.UART.Close(hPort)
        btnClose.Enabled = False
        btnOpen.Enabled = True
    End Sub

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Dim respon(20) As Byte
        PACNET.Sys.ChangeSlot(Convert.ToSByte(cmbSlot.Text))
        Dim iret As Boolean = PACNET.UART.SendCmd(hPort, PACNET.MISC.AnsiString(txtSend.Text), respon)
        If (iret = False) Then
            MessageBox.Show("send error")
        Else
            txtRespone.Text = PACNET.MISC.WideString(respon)
        End If
    End Sub
End Class
