Public Class Form1

    Private Sub btnReadDI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadDI.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ReadDI(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue.Text = value.ToString("X")
        End If
    End Sub

    Private Sub btnClearCnt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearCnt.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim DIcurchannel As Integer = txtDICNTChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ClearDICNT(hPort, slot, DIcurchannel, channel)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue.Text = ""
        End If
    End Sub

    Private Sub btnReadCnt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadCnt.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim DIcurchannel As Integer = txtDICNTChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ReadDICNT(hPort, slot, DIcurchannel, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            textBox1.Text = value.ToString()
        End If
    End Sub

    Private Sub btnReadDI_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadDI_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ReadDI_MF(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue.Text = value.ToString("X")
        End If
    End Sub

    Private Sub btnClearCnt_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearCnt_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim DIcurchannel As Integer = txtDICNTChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ClearDICNT_MF(hPort, slot, DIcurchannel, channel)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue.Text = ""
        End If
    End Sub

    Private Sub btnReadCnt_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadCnt_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim DIcurchannel As Integer = txtDICNTChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ReadDICNT_MF(hPort, slot, DIcurchannel, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            textBox1.Text = value.ToString()
        End If
    End Sub
End Class
