Public Class Form1

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim value As UInteger
        Dim hPort As IntPtr
        '87k module must use com port to send data
        hPort = PACNET.UART.Open("")
        'use pac_ReadDI read DI data
        Dim iret As Boolean = PACNET.PAC_IO.ReadDI(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue.Text = value.ToString("X")
        End If

        slot = cmbSlot2.Text
        channel = txtChannel2.Text
        '8k module have not using com port send data 
        iret = PACNET.PAC_IO.ReadDI(0, slot, channel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue2.Text = value.ToString("X")
        End If
    End Sub

    Private Sub btnRead_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim value As UInteger
        Dim hPort As IntPtr
        '87k module must use com port to send data
        hPort = PACNET.UART.Open("")
        'use pac_ReadDI read DI data
        Dim iret As Boolean = PACNET.PAC_IO.ReadDI_MF(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue.Text = value.ToString("X")
        End If

        slot = cmbSlot2.Text
        channel = txtChannel2.Text
        '8k module have not using com port send data 
        iret = PACNET.PAC_IO.ReadDI(0, slot, channel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtValue2.Text = value.ToString("X")
        End If
    End Sub
End Class
