﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Text;
///I-8084W version 0.5.0.3, 2011/07/05
///I-8084W version 0.5.0.4, 2011/07/19
///Add pac_i8084W_GetFirmwareVersion
///Fix bug for 0.5.0.3 wrong dll import declaration
///[DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetLowPassFilterUs")]

namespace pac8084WNet
{
    public class pac8084W
    {

        private class ICPDAS
        {

            // for I/O version management
            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_GetLibVersion")]                                      
            public static extern Int16 pac_i8084W_GetLibVersion();

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_GetFirmwareVersion")]
            public static extern Int16 pac_i8084W_GetFirmwareVersion(int slot, ref Int16 firmware);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_GetLibDate")]
            public static extern void pac_i8084W_GetLibDate(byte[] libDate);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_InitDriver")]
            public static extern Int16 pac_i8084W_InitDriver(int Slot);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetChannelMode")]
            public static extern Int16 pac_i8084W_SetChannelMode(int Slot, int Channel, Int16 Mode);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadCntABPhase")]
            public static extern Int16 pac_i8084W_ReadCntABPhase(int Slot, int Channel, ref Int32 Cnt32U, ref Int32 Overflow);    
                        
            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadCntPulseDir")]
            public static extern Int16 pac_i8084W_ReadCntPulseDir(int Slot, int Channel, ref Int32 Cnt32U, ref Int32 Overflow);


            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadCntUpDown")]
            public static extern Int16 pac_i8084W_ReadCntUpDown(int Slot, int Channel, ref Int32 Cnt32U, ref Int32 Overflow);


            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadFreq")]
            public static extern Int16 pac_i8084W_ReadFreq(int Slot, int Channel, ref UInt32 Freq);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadFreq_Float")]
            public static extern Int16 pac_i8084W_ReadFreq_Float(int Slot, int Channel, ref float Freq); 

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadCntUp")]  
            public static extern Int16 pac_i8084W_ReadCntUp(int Slot, int Channel,ref UInt32 Cnt32U, ref Int32  OverFlow);


            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ClrCnt")]
            public static extern Int16 pac_i8084W_ClrCnt(int Slot, int Channel);


            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_RecoverDefaultSetting")]
            public static extern void pac_i8084W_RecoverDefaultSetting(int Slot);


            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadXorRegister")]
            public static extern Int16 pac_i8084W_ReadXorRegister(int Slot, int Channel, ref Int32 XorReg);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetXorRegister")]
            public static extern Int16  pac_i8084W_SetXorRegister(int Slot, int Channel, Int16 XorReg);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadChannelMode")]
            public static extern Int16 pac_i8084W_ReadChannelMode(int Slot, int Channel, ref Int32 Mode);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadLowPassFilter_Us")]
            public static extern Int16 pac_i8084W_ReadLowPassFilter_Us(int Slot, int Channel, ref UInt16 Us);
           
            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetLowPassFilter_Us")]   
            public static extern Int16 pac_i8084W_SetLowPassFilter_Us(int Slot, int Channel, UInt16 Us);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadLowPassFilter_Status")]
            public static extern void pac_i8084W_ReadLowPassFilter_Status(int Slot, int Channel, ref Int32 Status);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetLowPassFilter_Status")]
            public static extern void pac_i8084W_SetLowPassFilter_Status(int Slot,int Channel,Int16 Status);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadFreqMode")]
            public static extern void pac_i8084W_ReadFreqMode(int Slot, int Channel, ref Int32 Mode);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetFreqMode")]   
            public static extern void pac_i8084W_SetFreqMode(int Slot, int Channel, Int16 Mode);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadFreqTimeoutValue")]
            public static extern UInt16 pac_i8084W_ReadFreqTimeoutValue(int Slot, int Channel );

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetFreqTimeoutValue")]
            public static extern void pac_i8084W_SetFreqTimeoutValue(int Slot, int Channel, UInt16 TimeOutValue );

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadDI_Xor")]
            public static extern Int16 pac_i8084W_ReadDI_Xor(int Slot, ref Int32 DI);


            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_ReadDI_XorLPF")]
            public static extern Int16 pac_i8084W_ReadDI_XorLPF(int Slot, ref Int32 DI);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_SetEdgeDetectMode")]
            public static extern Int16 pac_i8084W_SetEdgeDetectMode(int Slot, int Channel, Int32 EdgeMode);

            [DllImport("pac_i8084W.dll", EntryPoint = "pac_i8084W_GetEdgeDetectMode")]
            public static extern Int16 pac_i8084W_GetEdgeDetectMode(int Slot, int Channel,ref Int32 EdgeMode);

        }

        /// <summary>
        /// Get the firmware version of I-8084W in the specified slot.
        /// </summary>
        /// <param name="slot">1 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <returns>firmware version</returns>
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8084W_GetLibVersion();
        }

        /// <summary>
        /// Get the library version of this DLL (pac_i8084W.dll)
        /// </summary>
        /// <returns>library version</returns>
        public static Int16 FirmwareVersion(int slot,ref Int16 firmware)
        {
            return ICPDAS.pac_i8084W_GetFirmwareVersion(slot, ref firmware);
        }

        /// <summary>
        /// Get the building date of this DLL (pac_i8084W.dll)
        /// </summary>
        /// <returns>library building date</returns>
        public static string LibDate()
        {
            //return Arr2Str(ICPDAS.pac_i8017H_GetLibDate());
            byte[] libDate= new byte[32] ;
            ICPDAS.pac_i8084W_GetLibDate(libDate);
            //return libDate.Length.ToString();
            //Console.WriteLine("libDate= {0}  Len= {1}\n", AscArr2Str(libDate), libDate.Length.ToString());
            return AscArr2Str(libDate);
        }

        /// <summary>
        /// Initialize the I-8084W in the specified slot
        /// </summary>
        /// <param name="slot">1 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h</returns>
        public static Int16 Init(int slot)
        {
          //  Console.WriteLine("8084 Init dotnet {0}", slot);
            return ICPDAS.pac_i8084W_InitDriver(slot);
        }

        public static Int16 SetLED(int slot, UInt32 led)
        {
            return 0;
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }

        /// <summary>
        /// Set the operation mode of the specified channel of the I-8084W in the specified slot.
        /// The original function in pac_i8084W.dll is SetChannelMode()  
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="opMode">operation mode, including DirectionPulse, UpDown, Frequency, Up, Quadrant</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 SetChannelMode(int Slot, int Channel, Int16 Mode)
        {
	        return ICPDAS.pac_i8084W_SetChannelMode(Slot, Channel, Mode);
        }

        /// <summary>
        /// Get the operation mode of the specified channel of the I-8084W in the specified slot.
        /// The original function in pac_i8084W.dll is ReadChannelMode()  
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="opMode">operation mode, including DirectionPulse, UpDown, Frequency, Up, Quadrant</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadChannelMode(int Slot, int Channel, ref Int16 Mode)
        {
            Int32 m = 0;
	        Int16 ret = ICPDAS.pac_i8084W_ReadChannelMode(Slot, Channel, ref m);
            Mode = (Int16)(m & 0xffff);
            return ret;
        }

        /// <summary>
        /// Recover the default settings of the I-8084W in the specified slot.
        /// Note: Default settings are as followings:
        /// XOR register=0 (active high); 
        /// channel mode= 3 (Up counter mode); 
        /// Frequency operate mode = 0 (normal mode); 
        /// Low Pass Filter status = disable; 
        /// Low Pass Filter signal width = 1 us; 
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        public static void RecoverDefaultSetting(int Slot)
        {
	        ICPDAS.pac_i8084W_RecoverDefaultSetting( Slot);
        }

        /// <summary>
        /// Depreciated.     
        /// Use ReadCount() instead.
        /// Read the counts of Dir/Pulse mode in the specified channel.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="Cnt32U">the counts (direction=0, negative counts; direction=1, positive counts)</param>
        /// <param name="overflow">the count status, overflow: 1; not overflow: 0</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>            
        public static Int16 ReadPulseDir(int Slot, int Channel,ref Int32 Cnt32U,ref Int16 Overflow)
        {
            Int32 o = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadCntPulseDir(Slot, Channel, ref Cnt32U, ref o);
            Overflow = (Int16)(o & 0xffff);
            return ret;
        }

        /// <summary>
        /// Depreciated.     
        /// Use ReadCount() instead.
        /// Read the counts of Up/Down mode in the specified channel.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="Cnt32U">the counts read back</param>
        /// <param name="overflow">the count status, overflow: 1; not overflow: 0</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadUpDown(int Slot, int Channel,ref Int32 Cnt32U,ref Int16 Overflow)
        {
            Int32 o = 0;
	        Int16 ret = ICPDAS.pac_i8084W_ReadCntUpDown( Slot, Channel,ref Cnt32U,ref o);
            Overflow = (Int16)(o & 0xffff);
            return ret;
        }

        /// <summary>
        /// Read the frequency in the specified channel of the I-8084W in the specified slot.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="frequency">the frequency in the specified channel (unit: Hz)</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadFreq(int Slot, int Channel, ref UInt32 Freq)
        {
	        return ICPDAS.pac_i8084W_ReadFreq(Slot, Channel, ref Freq); 
        }



        public static Int16 ReadFreqFloat(int Slot, int Channel, ref float  Freq)
        {
            return ICPDAS.pac_i8084W_ReadFreq_Float(Slot, Channel, ref Freq);
        }

        /// <summary>
        /// Depreciated.     
        /// Use ReadCount() instead.
        /// Read the counts of Up mode of the specified channel.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="Cnt32U">the counts read back</param>
        /// <param name="overflow">the count status, overflow: 1; not overflow: 0</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadUpCnt(int Slot, int Channel,ref UInt32 Cnt32U, ref UInt16 OverFlow)
        {
            Int32 o = 0;
	        Int16 ret= ICPDAS.pac_i8084W_ReadCntUp(Slot, Channel,ref Cnt32U, ref o);
            OverFlow = (UInt16)(o & 0xffff);
            return ret;
        }

        /// <summary>
        /// Depreciated.     
        /// Use ReadCount() instead.
        /// Read the counts of Quadrant mode in the specified channel.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="Cnt32U">the counts read back</param>
        /// <param name="overflow">the count status, overflow: 1; not overflow: 0</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadABPhase(int Slot, int Channel,ref Int32 Cnt32U,ref Int16 Overflow)
        {
            Int32 o = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadCntABPhase(Slot, Channel, ref Cnt32U, ref o);
            Overflow = (Int16)(o & 0xffff);
            return ret;
        }

        /// <summary>
        /// Clear the counts of the specified channel of I-8084W in the specified slot..
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static void ClrCnt(int Slot, int Channel)
        {
	        ICPDAS.pac_i8084W_ClrCnt( Slot, Channel);
        }



        /// <summary>
        /// Depreciated.     
        /// Use ReadActiveState() instead.
        /// Read XOR register to see that input signal as active low or active high.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="xorRegister">0: active high (signal: Low -> High, count changed); 1: active low</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static  Int16 ReadXor(int Slot, int Channel, ref Int16 XorReg)
        {
            Int32 x = 0;
	        Int16 ret = ICPDAS.pac_i8084W_ReadXorRegister(Slot, Channel, ref x);
            XorReg = (Int16)(x & 0xffff);
            return ret;
        }

        /// <summary>
        /// Depreciated.     
        /// Use SetActiveState() instead.
        /// Set XOR register to make input signal as active low or active high.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="xorRegister">0: active high (signal: Low -> High, count changed); 1: active low</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 SetXor(int Slot, int Channel, Int16 XorReg)
        {
	        return ICPDAS.pac_i8084W_SetXorRegister(Slot, Channel, XorReg);
        }


        /// <summary>
        /// Read the width of low pass filter in the specified channel of the I-8084W in the specified slot.
        /// I-8084W has only three independent 2nd-order digital noise filters to remove noises.
        /// Channel 0/1 use the first; channel 2/3 use the second; channel 4/5/6/7 use the third.
        /// Assume that (high level width of input signal) = x, 
        /// if x is less than us, then the input signal is filtered.
        /// if x is greater than 2*us, then the input signal passes.
        /// if x is between us and 2*us, then some passes and some be filtered.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="us">1~32767, pulse width, unit= 1us</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadLowPassFilter_Us(int Slot, int Channel, ref UInt16 Us)
        {
	        return ICPDAS.pac_i8084W_ReadLowPassFilter_Us(Slot, Channel, ref Us);
        }

        /// <summary>
        /// Set the width of low pass filter in the specified channel of the I-8084W in the specified slot.
        /// I-8084W has only three independent 2nd-order digital noise filters to remove noises.
        /// Channel 0/1 use the first; channel 2/3 use the second; channel 4/5/6/7 use the third.
        /// Assume that (high level width of input signal) = x, 
        /// if x is less than us, then the input signal is filtered.
        /// if x is greater than 2*us, then the input signal passes.
        /// if x is between us and 2*us, then some passes and some be filtered.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="us">1~32767, pulse width, unit= 1us</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        
        public static Int16 SetLowPassFilter_Us(int Slot, int Channel, UInt16 Us)
        {
	        return ICPDAS.pac_i8084W_SetLowPassFilter_Us(Slot, Channel, Us);
        }

        /// <summary>
        /// Read the status of low pass filter in the specified channel of the I-8084W in the specified slot.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="status">the status of low pass filter, Disabled or Enabled</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static void ReadLowPassFilter_Status(int Slot,int Channel,ref Int16 Status)
        {
            Int32 s = 0;
	        ICPDAS.pac_i8084W_ReadLowPassFilter_Status(Slot,Channel,ref s);
            Status = (Int16)(s & 0xffff);
        }

        /// <summary>
        /// Set the status of low pass filter in the specified channel of the I-8084W in the specified slot.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="status">the status of low pass filter, Disabled or Enabled</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static void SetLowPassFilter_Status(int Slot,int Channel,Int16 Status)
        {
	        ICPDAS.pac_i8084W_SetLowPassFilter_Status(Slot,Channel,Status);
        }

        /// <summary>
        /// Read the frequency mode in the specified channel of the I-8084W in the specified slot.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="freqMode">the frequency mode in the specified channel, Normal or HighSpeed</param>

        public static void ReadFreqMode(int Slot, int Channel, ref Int16 Mode)
        {
            Int32 m = 0;
	        ICPDAS.pac_i8084W_ReadFreqMode(Slot, Channel, ref m);
            Mode = (Int16)(m & 0xffff);
        }

        /// <summary>
        /// Set the frequency mode in the specified channel of the I-8084W in the specified slot.
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="freqMode">the frequency mode in the specified channel, Normal or HighSpeed</param>
        public static void SetFreqMode(int Slot, int Channel, Int16 Mode)
        {
	        ICPDAS.pac_i8084W_SetFreqMode(Slot,Channel,Mode);
        }

        /// <summary>
        /// Read the timeout value while measuring frequecny in the specified channel of the I-8084W
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <returns>timeout value while measuring frequency (unit: ms)</returns>
        public static UInt16 ReadFreqTimeoutValue(int Slot, int Channel )
        {
	        return ICPDAS.pac_i8084W_ReadFreqTimeoutValue(Slot, Channel );
        }

        /// <summary>
        /// Set the timeout value while measuring frequecny in the specified channel of the I-8084W
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="timeoutValue">timeout value while measuring frequency (unit: ms)</param>
        public static void SetFreqTimeoutValue(int Slot, int Channel, UInt16 TimeOutValue )
        {
	        ICPDAS.pac_i8084W_SetFreqTimeoutValue(Slot, Channel, TimeOutValue );
        }

        /// <summary>
        /// Read the DI value after xor operation in the specified channel.
        /// I-8084W uses xor operations to toggle active states of each channel.
        /// The original function in pac_i8084W.dll is ReadDIXor().
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="digitalInput">the value of digital input which represents DI status of 8 channels</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadDI_Xor(int Slot, ref Int16 DI)
        {
            Int32 i = 0;
	        Int16 ret = ICPDAS.pac_i8084W_ReadDI_Xor( Slot, ref i);
            DI = (Int16)(i & 0xffff);
            return ret;
        }

        /// <summary>
        /// Read the DI value after xor operation and Low pass filter in the specified channel.
        /// I-8084W uses xor operations to toggle active states of each channel.
        /// The original function in pac_i8084W.dll is ReadDIXorLPF().
        /// </summary>
        /// <param name="slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="digitalInput">the value of digital input which represents DI status of 8 channels</param>
        /// <returns>Error Code of the DLL, pac_i8084W.dll (refer to pac_i8084W.h)</returns>
        public static Int16 ReadDI_XorLPF(int Slot,ref Int16 DI)
        {
            Int32 i = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadDI_XorLPF(Slot, ref i);
            DI = (Int16)(i & 0xffff);
            return ret;
        }
        /// <summary>
        /// Get the detect mode for rising edge/falling edge
        /// </summary>
        /// <param name="Slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="Channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="Mode">0: rising edge mode, 1: falling edge mode</param>
        public static void GetEdgeMode(int Slot, int Channel, ref Int16 Mode)
        {
            Int32 m = 0;
            ICPDAS.pac_i8084W_GetEdgeDetectMode(Slot, Channel, ref m);
            Mode = (Int16)(m & 0xffff);
        }

        /// <summary>
        /// Set the detect mode for rising edge/falling edge
        /// </summary>
        /// <param name="Slot">0 ~ 7 (the slot which I-8084W is inserted)</param>
        /// <param name="Channel">0 ~ 7 (from where the input comes)</param>
        /// <param name="Mode">0: rising edge mode, 1: falling edge mode</param>
        public static void SetEdgeMode(int Slot, int Channel, Int16 Mode)
        {

            ICPDAS.pac_i8084W_SetEdgeDetectMode(Slot, Channel, Mode);
        }
    }
}
