﻿
Imports pac8093WNet

Public Class Form1
    Private typeStr As String() = New String(2) {}
    Private slotStr As String() = New String(7) {}
    Private slotIndex As Integer


   
   
  
   
   
    
    Private Sub SetPresetValue(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPreset0.Click, cmdPreset2.Click, cmdPreset1.Click
        Dim valText As TextBox() = New TextBox() {txtPreset0, txtPreset1, txtPreset2}
        Dim index As Int16 = Int16.Parse(DirectCast(sender, Button).Tag.ToString())
        pac8093W.SetPreset(slotIndex, index, Convert.ToInt32(valText(index).Text))
    End Sub
    Private Sub SetLatchIndex(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckLatch2.Click, ckLatch1.Click, ckLatch0.Click
        Dim index As Int16 = Int16.Parse(DirectCast(sender, CheckBox).Tag.ToString())
        Dim ckLatch As CheckBox = DirectCast(sender, CheckBox)
        If ckLatch.Checked Then
            pac8093W.SetIndexLatchStatus(slotIndex, index, 1)
        Else
            pac8093W.SetIndexLatchStatus(slotIndex, index, 0)
        End If
    End Sub

    Private Sub cboSlotIndex_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        Dim ret As Int16
        slotIndex = cboSlotIndex.SelectedIndex

        ret = pac8093W.Init(slotIndex)
        If ret = 0 Then
            txtLibVer.Text = [String].Format("{0:X4}", pac8093W.LibVersion())

            txtLibDate.Text = pac8093W.LibDate()

            txtFirmware.Text = [String].Format("{0:X4}", pac8093W.FirmwareVersion(slotIndex))
            GetChannelXOR()
        Else
            Me.Text = "Can not find 8093W at slot " + ret.ToString()
        End If
    End Sub

    

    Private Sub cboMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMode.SelectedIndexChanged
        Dim mode As Integer
        mode = cboMode.SelectedIndex
        Dim ch As Integer
        ch = 0
        For ch = 0 To 2
            pac8093W.SetChannelMode(slotIndex, ch, mode)
            ' for Demo to set all channels as same channel mode
            pac8093W.ResetEncoder(slotIndex, ch)
        Next ch
    End Sub

    Private Sub SetXOR(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckXOR2.Click, ckXOR1.Click, ckXOR0.Click
        Dim index As Int16 = Int16.Parse(DirectCast(sender, CheckBox).Tag.ToString())
        Dim ckXor As CheckBox = DirectCast(sender, CheckBox)
        If ckXor.Checked Then
            pac8093W.SetXor(slotIndex, index, 1)
        Else
            pac8093W.SetXor(slotIndex, index, 0)
        End If

        GetChannelXOR()
    End Sub

    Private Sub GetChannelXOR()
        Dim ch As Integer
        Dim xorBox As CheckBox() = New CheckBox() {ckXOR0, ckXOR1, ckXOR2}
        Dim [xor] As Int32 = 0
        ch = 0
        For ch = 0 To 2
            pac8093W.ReadXor(slotIndex, ch, [xor])
            If [xor] = 0 Then
                xorBox(ch).Checked = False
            Else
                xorBox(ch).Checked = True

            End If
        Next ch


    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click
        Dim ch As Integer
        For ch = 0 To 7
            pac8093W.ResetEncoder(slotIndex, ch)
        Next ch
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim c_status As Int32 = 0, ifEnableLatch As Int32 = 0, latchedStatus As Int32 = 0
        Dim valText As TextBox() = New TextBox() {txtCH00, txtCH01, txtCH02}
        Dim enLatchText As TextBox() = New TextBox() {txtEn0, txtEn1, txtEn2}
        Dim latchStatusText As TextBox() = New TextBox() {txtL0, txtL1, txtL2}
        Dim zText As TextBox() = New TextBox() {txtZ0, txtZ1, txtZ2}
        Dim freqText As TextBox() = New TextBox() {txtFreq0, txtFreq1, txtFreq2}
        Dim lVal As Int32 = 0
        Dim freq As Single = 0

        Dim ch As Integer
        ch = 0
        For ch = 0 To 2

            pac8093W.ReadEncoder(slotIndex, ch, lVal)

            valText(ch).Text = lVal.ToString()
            pac8093W.ReadIndex(slotIndex, ch, c_status)
            zText(ch).Text = c_status.ToString()

            pac8093W.GetIndexLatchStatus(slotIndex, ch, ifEnableLatch, latchedStatus)
            enLatchText(ch).Text = ifEnableLatch.ToString()
            latchStatusText(ch).Text = latchedStatus.ToString()
            pac8093W.ReadFreq(slotIndex, ch, freq)


            freqText(ch).Text = freq.ToString()
        Next ch
    End Sub


   
End Class
