﻿Imports pac8172WNet
Public Class Form1
    Private Shared slotIndex As Integer = 0, port As Integer = 0, group As Integer = 0
    Private Shared bitMode As Int16 = 12

    Private Sub cboSlot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlot.SelectedIndexChanged
        Dim ret As Integer = -1

        ret = pac8172W.Init(cboSlot.SelectedIndex)
        If ret = 0 Then
            slotIndex = cboSlot.SelectedIndex
        Else
            MessageBox.Show("I-8172W is not at slot " + cboSlot.SelectedIndex.ToString())
        End If
    End Sub
    Private Sub cboPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboPort.SelectedIndexChanged
        port = cboPort.SelectedIndex
    End Sub

    ' for input FRnet I/O , the group index start from 8~15
    ' for output FRnet I/O the group index start from 0~7
    Private Sub cboGroup_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboGroup.SelectedIndexChanged
        group = cboGroup.SelectedIndex + 8
    End Sub
  
    Private Sub Write_AO(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAO0.Click, btnAO3.Click, btnAO2.Click, btnAO1.Click
        Dim AO As TextBox() = New TextBox() {txtAO0, txtAO1, txtAO2, txtAO3}
        Dim cbo As ComboBox() = {cboType0, cboType1, cboType2, cboType3}

        Dim index As Int16 = Int16.Parse(DirectCast(sender, Button).Tag.ToString())

        Dim typeCode As Int16 = cbo(index).SelectedIndex + &H30

        pac8172WNet.pac8172W.WriteAOFloat(slotIndex, port, group, bitMode, index, typeCode, _
         Convert.ToSingle(AO(index).Text), 0)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        Dim cbo As ComboBox() = {cboType0, cboType1, cboType2, cboType3}

        cboPort.SelectedIndex = 0
        cboGroup.SelectedIndex = 0

        i = 0
        For i = 0 To 3
            ' type code = 0x8 +-10 V
            cbo(i).SelectedIndex = 3
        Next i

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub
    
  
   
End Class
