VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "watch dog demo"
   ClientHeight    =   4170
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3780
   LinkTopic       =   "Form1"
   ScaleHeight     =   4170
   ScaleWidth      =   3780
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdWDT_Disable 
      Caption         =   "Stop WatchDog"
      Height          =   495
      Left            =   840
      TabIndex        =   9
      Top             =   2880
      Width           =   2775
   End
   Begin VB.Timer TimerWDT 
      Enabled         =   0   'False
      Left            =   3000
      Top             =   600
   End
   Begin VB.CommandButton cmdWDT_Stop 
      Caption         =   "Stop refreshing WatchDogTimer"
      Height          =   495
      Left            =   840
      TabIndex        =   8
      Top             =   2280
      Width           =   2775
   End
   Begin VB.CommandButton cmdWDT_Start 
      Caption         =   "Start WatchDog and refresh"
      Height          =   495
      Left            =   840
      TabIndex        =   7
      Top             =   1680
      Width           =   2775
   End
   Begin VB.TextBox txtRefresh 
      Height          =   375
      Left            =   1560
      TabIndex        =   6
      Text            =   "0"
      Top             =   3600
      Width           =   1215
   End
   Begin VB.TextBox txtWDT_Time 
      Height          =   375
      Left            =   1680
      TabIndex        =   3
      Text            =   "4"
      Top             =   600
      Width           =   1095
   End
   Begin VB.ComboBox cmbWDT_mode 
      Height          =   315
      ItemData        =   "watchdog.frx":0000
      Left            =   1800
      List            =   "watchdog.frx":000A
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label Label5 
      Caption         =   "Step3"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   1680
      Width           =   495
   End
   Begin VB.Label Label4 
      Caption         =   "Refresh times"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   3600
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "(Hardware WDT: 0~63 (Unit is 0.5 s) OS WDT: Unit is s)"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   1080
      Width           =   2775
   End
   Begin VB.Label Label2 
      Caption         =   "Step2:watch dog time"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Step1:watch dog mode"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WDT_OS As Integer
Dim WDT_HW As Integer
Dim WDT_Type As Long
Dim Counter As Integer

Private Sub cmdWDT_Disable_Click()
'Disable watch dog
pac_DisableWatchDog (WDT_Type)
TimerWDT.Enabled = False
End Sub

Private Sub cmdWDT_Start_Click()
Dim ret As Boolean
Dim WDTTime As Long
'Get watch dog type
WDT_Type = cmbWDT_mode.ListIndex
Counter = 0
'Get watch dog time
WDTTime = CLng(txtWDT_Time.Text)
'Enable watch dog
ret = pac_EnableWatchDog(WDT_Type, WDTTime)
If ret = False Then
    MsgBox "pac_EnableWatchDog fail", vbOKOnly, "Enable watch dog"
Else
   Select Case WDT_Type
    Case WDT_OS
        'Set refresh time for timer
        TimerWDT.Interval = WDTTime * 1000 / 3

    Case WDT_HW
        'Set refresh time for timer
        TimerWDT.Interval = WDTTime * 0.5 * 1000 / 3

   End Select
    'Enable timer to refresh watch dog
    TimerWDT.Enabled = True
End If
End Sub

Private Sub cmdWDT_Stop_Click()
'Stop to refresh watch dog
TimerWDT.Enabled = False
End Sub

Private Sub Form_Load()
cmbWDT_mode.ListIndex = 0

WDT_OS = 1
WDT_HW = 0
End Sub

Private Sub TimerWDT_Timer()
'Refresh watch dog
pac_RefreshWatchDog (WDT_Type)
txtRefresh.Text = CStr(Counter)
Counter = Counter + 1
End Sub
