// 87K_basicDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87K_basic.h"
#include "87K_basicDlg.h"
#include "pacsdk.h"
#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87K_basicDlg dialog

CMy87K_basicDlg::CMy87K_basicDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87K_basicDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87K_basicDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87K_basicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87K_basicDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87K_basicDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87K_basicDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_btnOpenCom, OnbtnOpenCom)
	ON_BN_CLICKED(IDC_btnCloseCom, OnbtnCloseCom)
	ON_BN_CLICKED(IDC_btnSend, OnbtnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87K_basicDlg message handlers

BOOL CMy87K_basicDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//set default value
	SetDlgItemText(IDC_EDITCmd,"$00M");
	SetDlgItemText(IDC_COMBOSlot,"1");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy87K_basicDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy87K_basicDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy87K_basicDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

HANDLE hPort;

void CMy87K_basicDlg::OnbtnOpenCom() 
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it opens COM1 port and set baud rate to 115200
	//COM1 port connects to backplane
	hPort = uart_Open("");
	if(hPort == (HANDLE)(-1)){
		::MessageBox(NULL,"Open Port error","87k_basic",MB_OK);
	}else{
		GetDlgItem(IDC_btnOpenCom)->EnableWindow(FALSE);
		GetDlgItem(IDC_btnCloseCom)->EnableWindow(TRUE);
		GetDlgItem(IDC_btnSend)->EnableWindow(TRUE);
	}
}

void CMy87K_basicDlg::OnbtnCloseCom() 
{
	// TODO: Add your control notification handler code here
	//close port
	uart_Close(hPort);
	GetDlgItem(IDC_btnOpenCom)->EnableWindow(TRUE);
	GetDlgItem(IDC_btnCloseCom)->EnableWindow(FALSE);
	GetDlgItem(IDC_btnSend)->EnableWindow(FALSE);
}

void CMy87K_basicDlg::OnbtnSend() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	char strTemp[20];//char instead of CString strTemp,or it can't get the correct string
	char SendData[20];
	char Response[20]={0};

	//get slot
	GetDlgItemText(IDC_COMBOSlot,temp,10);
	BYTE slot = atoi(temp);
	pac_ChangeSlot(slot);

	//get command string
	GetDlgItemText(IDC_EDITCmd,strTemp,10);
	for(int i= 0;i<sizeof(strTemp);i++){
		SendData[i] = strTemp[i];
	}

	//use uart_SendCmdExt function to send command, and use 3th parameter to get result
	BOOL iret = uart_SendCmdExt(hPort, SendData, sizeof(SendData), Response, sizeof(Response));
	if(!iret){
		::MessageBox(NULL,"send error","87k_basic",MB_OK);
	}else{
		int length = strlen(Response);
		ZeroMemory(temp,20);
		for(int i=0;i<length;i++){
			temp[i] = Response[i];
		}
		SetDlgItemText(IDC_EDITRes,temp);
	}
}
