Public Class Form1
  
    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = Convert.ToUInt32(txtDOValue.Text, 16)

        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, DOChannel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")

        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, DOChannel, 0)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO(hPort, slot, DIChannel, DOChannel, value, 0)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtDIValue.Text = value.ToString("X")
    End Sub

    Private Sub btnRead_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = New UInteger()
        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO_MF(hPort, slot, DIChannel, DOChannel, value, 0)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtDIValue.Text = value.ToString("X")
    End Sub
End Class
