Public Class Form1
   
    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = Convert.ToUInt32(txtValue.Text, 16)
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, channel, 0)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnWrite_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim value As UInteger = Convert.ToUInt32(txtValue.Text, 16)
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnClear_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, slot, channel, 0)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub
End Class
