Public Class Form1

    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtDOChannel.Text
        Dim value As UInteger = Convert.ToUInt32(txtDOValue.Text, 16)
        '87k module must use com port send data
        Dim hPort As IntPtr = PACNET.UART.Open("")
        'use pac_WriteDO function write do
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        slot = cmbSlot2.Text
        channel = txtDOChannel2.Text
        value = Convert.ToUInt32(txtDOValue2.Text, 16)
        '8k module have not using com port send data
        iret = PACNET.PAC_IO.WriteDO(0, slot, channel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtDOChannel.Text
        '87k module must use com port send data
        Dim hPort As IntPtr = PACNET.UART.Open("")
        'use pac_WriteDO function write '0' DO data to clear
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, channel, 0)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        slot = cmbSlot2.Text
        channel = txtDOChannel2.Text
        '8k module have not using com port send data and use pac_WriteDO function write '0' DO data to clear
        iret = PACNET.PAC_IO.WriteDO(0, slot, channel, 0)

        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOValue As UInteger
        Dim DIValue As UInteger
        '87k module must use com port send data
        Dim hPort As IntPtr = PACNET.UART.Open("")

        'DIO module must use pac_ReadDIO function read DI data
        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO(hPort, slot, DIChannel, DOChannel, DIValue, DOValue)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDIValue.Text = DIValue.ToString("X")

        slot = cmbSlot2.Text
        DOChannel = txtDOChannel2.Text
        DIChannel = txtDIChannel2.Text
        '8k module have not using com port send data and DIO module must use pac_ReadDIO function read DI data
        PACNET.PAC_IO.ReadDIO(0, slot, DIChannel, DOChannel, DIValue, DOValue)

        txtDIValue2.Text = DIValue.ToString("X")
    End Sub

    Private Sub btnWrite_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtDOChannel.Text
        Dim value As UInteger = Convert.ToUInt32(txtDOValue.Text, 16)
        '87k module must use com port send data
        Dim hPort As IntPtr = PACNET.UART.Open("")
        'use pac_WriteDO function write do
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, slot, channel, value)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        slot = cmbSlot2.Text
        channel = txtDOChannel2.Text
        value = Convert.ToUInt32(txtDOValue2.Text, 16)
        '8k module have not using com port send data
        iret = PACNET.PAC_IO.WriteDO(0, slot, channel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnClear_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtDOChannel.Text
        '87k module must use com port send data
        Dim hPort As IntPtr = PACNET.UART.Open("")
        'use pac_WriteDO function write '0' DO data to clear
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, slot, channel, 0)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        slot = cmbSlot2.Text
        channel = txtDOChannel2.Text
        '8k module have not using com port send data and use pac_WriteDO function write '0' DO data to clear
        iret = PACNET.PAC_IO.WriteDO(0, slot, channel, 0)

        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnRead_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead_MF.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOValue As UInteger
        Dim DIValue As UInteger
        '87k module must use com port send data
        Dim hPort As IntPtr = PACNET.UART.Open("")

        'DIO module must use pac_ReadDIO function read DI data
        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO_MF(hPort, slot, DIChannel, DOChannel, DIValue, DOValue)
        PACNET.UART.Close(hPort)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDIValue.Text = DIValue.ToString("X")

        slot = cmbSlot2.Text
        DOChannel = txtDOChannel2.Text
        DIChannel = txtDIChannel2.Text
        '8k module have not using com port send data and DIO module must use pac_ReadDIO function read DI data
        PACNET.PAC_IO.ReadDIO(0, slot, DIChannel, DOChannel, DIValue, DOValue)

        txtDIValue2.Text = DIValue.ToString("X")
    End Sub
End Class
