﻿Imports pac8088WNet

Public Class Form1

    Private slotStr As String() = New String(7) {}
    Private slotIndex As Integer

   

  

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        slotStr(0) = "Slot 0"
        slotStr(1) = "Slot 1"
        slotStr(2) = "Slot 2"
        slotStr(3) = "Slot 3"
        slotStr(4) = "Slot 4"
        slotStr(5) = "Slot 5"
        slotStr(6) = "Slot 6"
        slotStr(7) = "Slot 7"
    End Sub

    
    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim pwmStatus As Int32 = 0
        Dim pwmBitArr As Int32() = New Int32(7) {}
        Dim diArr As Label() = New Label() {lbDI0, lbDI1, lbDI2, lbDI3, lbDI4, lbDI5, _
         lbDI6, lbDI7}
        Dim pwmArr As Label() = New Label() {pwm0, pwm1, pwm2, pwm3, pwm4, pwm5, _
         pwm6, pwm7}
        Dim diVal As UInt16 = 0
        Dim diBit As Int16() = New Int16(7) {}
        If slotIndex <> -1 Then
            pac8088W.GetDI(slotIndex, diVal, diBit)
            pac8088W.GetPWMActiveState(slotIndex, pwmStatus, pwmBitArr)
            Dim i As Integer = 0
            For i = 0 To 7
                If pwmBitArr(i) = 1 Then
                    pwmArr(i).Text = "ON"
                Else
                    pwmArr(i).Text = "OFF"
                End If
            Next i

        End If
    End Sub

    Private Sub cboSlotIndex_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        If pac8088W.Init(cboSlotIndex.SelectedIndex) = 0 Then
            slotIndex = cboSlotIndex.SelectedIndex
            txtLibVer.Text = [String].Format("{0:X4}", pac8088W.LibVersion())

            txtLibDate.Text = pac8088W.LibDate()
            txtFirmware.Text = [String].Format("{0:X4}", pac8088W.FirmwareVersion(slotIndex))
        Else
            slotIndex = -1
            txtLibVer.Text = "-1"
            txtLibDate.Text = "none"
            txtFirmware.Text = "-1"
        End If
    End Sub

    Private Sub Start_PWM(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart7.Click, btnStart6.Click, btnStart5.Click, btnStart4.Click, btnStart3.Click, btnStart2.Click, btnStart1.Click, btnStart0.Click
        Dim index As Int16 = Int16.Parse(DirectCast(sender, Button).Tag.ToString())
        pac8088W.PWM_Start(slotIndex, index)
    End Sub

    Private Sub Set_BurstCnt(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetCnt_7.Click, btnSetCnt_0.Click, btnSetCnt_1.Click, btnSetCnt_2.Click, btnSetCnt_3.Click, btnSetCnt_4.Click, btnSetCnt_5.Click, btnSetCnt_6.Click
        Dim cntArr As TextBox() = New TextBox() {txtCnt0, txtCnt1, txtCnt2, txtCnt3, txtCnt4, txtCnt5, txtCnt6, txtCnt7}
        Dim index As Int16 = Int16.Parse(DirectCast(sender, Button).Tag.ToString())
        Dim burstCnt As UInt16 = Convert.ToUInt16(cntArr(index).Text)
        pac8088W.SetBurstCount(slotIndex, index, burstCnt)
    End Sub

    Private Sub Stop_PWM(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop7.Click, btnStop6.Click, btnStop5.Click, btnStop4.Click, btnStop3.Click, btnStop2.Click, btnStop1.Click, btnStop0.Click
        Dim index As Int16 = Int16.Parse(DirectCast(sender, Button).Tag.ToString())
        pac8088W.PWM_Stop(slotIndex, index)
    End Sub

    Private Sub Set_TriggerState(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboTrigState7.SelectedIndexChanged, cboTrigState6.SelectedIndexChanged, cboTrigState5.SelectedIndexChanged, cboTrigState4.SelectedIndexChanged, cboTrigState3.SelectedIndexChanged, cboTrigState2.SelectedIndexChanged, cboTrigState1.SelectedIndexChanged, cboTrigState0.SelectedIndexChanged
        Dim stateArr As ComboBox() = New ComboBox() {cboTrigState0, cboTrigState1, cboTrigState2, cboTrigState3, cboTrigState4, cboTrigState5, cboTrigState6, cboTrigState7}
        Dim index As Int16 = Int16.Parse(DirectCast(sender, ComboBox).Tag.ToString())

        Dim state As Integer = stateArr(index).SelectedIndex

        pac8088W.SetHardwareTrigChannel(slotIndex, index, state)

        Dim readbackState As Integer = 0
        pac8088W.GetHardwareTrigChannel(slotIndex, index, readbackState)

        stateArr(index).SelectedIndex = readbackState
    End Sub

    Private Sub Set_PulseMode(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMode7.SelectedIndexChanged, cboMode6.SelectedIndexChanged, cboMode5.SelectedIndexChanged, cboMode4.SelectedIndexChanged, cboMode3.SelectedIndexChanged, cboMode2.SelectedIndexChanged, cboMode1.SelectedIndexChanged, cboMode0.SelectedIndexChanged
        Dim modeArr As ComboBox() = New ComboBox() {cboMode0, cboMode1, cboMode2, cboMode3, cboMode4, cboMode5, cboMode6, cboMode7}
        Dim index As Int16 = Int16.Parse(DirectCast(sender, ComboBox).Tag.ToString())
        Dim mode As Byte = modeArr(index).SelectedIndex
        pac8088W.SetPWMCountMode(slotIndex, index, mode)
    End Sub

    Private Sub Set_DutyHz(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button8.Click, button7.Click, button6.Click, button5.Click, button4.Click, button3.Click, button2.Click, button1.Click
        Dim deci_hz As UInt32 = 0
        Dim deci_duty As UInt16 = 0
        Dim hzArr As TextBox() = New TextBox() {txtHz0, txtHz1, txtHz2, txtHz3, txtHz4, txtHz5, _
         txtHz6, txtHz7}

        Dim dutyArr As TextBox() = New TextBox() {txtDuty0, txtDuty1, txtDuty2, txtDuty3, txtDuty4, txtDuty5, _
         txtDuty6, txtDuty7}

        Dim index As Int16 = Int16.Parse(DirectCast(sender, Button).Tag.ToString())

        Dim hz As UInt32 = Convert.ToUInt32(hzArr(index).Text)
        Dim duty As UInt16 = Convert.ToUInt16(dutyArr(index).Text)
        pac8088W.SetPWMDuty(slotIndex, index, hz, duty)

        pac8088W.GetRealPWMDuty_Deci(slotIndex, index, deci_hz, deci_duty)

        hzArr(index).Text = (deci_hz / 10).ToString()
        dutyArr(index).Text = (deci_duty / 10).ToString()
    End Sub

    Private Sub Enable_SyncChannel(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckSync7.Click, ckSync6.Click, ckSync5.Click, ckSync4.Click, ckSync3.Click, ckSync2.Click, ckSync1.Click, ckSync0.Click
        Dim index As Int16 = Int16.Parse(DirectCast(sender, CheckBox).Tag.ToString())
        Dim enSynCh As CheckBox = DirectCast(sender, CheckBox)
        If enSynCh.Checked Then
            pac8088W.SetSyncChannel(slotIndex, index, 1)
        Else
            pac8088W.SetSyncChannel(slotIndex, index, 0)
        End If
    End Sub


  


    Private Sub btnSyncStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSyncStart.Click
        pac8088W.Sync_Start(slotIndex)
    End Sub

    Private Sub btnSyncStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSyncStop.Click
        pac8088W.Sync_Stop(slotIndex)
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()

    End Sub
End Class
