VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "87K di latch demo"
   ClientHeight    =   3390
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3195
   LinkTopic       =   "Form1"
   ScaleHeight     =   3390
   ScaleWidth      =   3195
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCleaDIrLatch 
      Caption         =   "Clear DI latch"
      Height          =   375
      Left            =   1560
      TabIndex        =   12
      Top             =   2880
      Width           =   1215
   End
   Begin VB.CommandButton cmdReadDI 
      Caption         =   "Read DI"
      Height          =   375
      Left            =   360
      TabIndex        =   11
      Top             =   2880
      Width           =   855
   End
   Begin VB.TextBox txtLowLatch 
      Height          =   285
      Left            =   2280
      TabIndex        =   10
      Text            =   "0"
      Top             =   2400
      Width           =   615
   End
   Begin VB.TextBox txtHighLatch 
      Height          =   285
      Left            =   2280
      TabIndex        =   9
      Text            =   "0"
      Top             =   2040
      Width           =   615
   End
   Begin VB.TextBox txtDIValue 
      Height          =   285
      Left            =   1560
      TabIndex        =   8
      Text            =   "0"
      Top             =   1560
      Width           =   615
   End
   Begin VB.TextBox txtDIChs 
      Height          =   375
      Left            =   1920
      TabIndex        =   3
      Text            =   "8"
      Top             =   600
      Width           =   495
   End
   Begin VB.ComboBox cmbSlot 
      Height          =   315
      ItemData        =   "i87K_di_latch.frx":0000
      Left            =   1080
      List            =   "i87K_di_latch.frx":0019
      TabIndex        =   1
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label6 
      Caption         =   "DI low latch value(Hex)"
      Height          =   255
      Left            =   360
      TabIndex        =   7
      Top             =   2400
      Width           =   1695
   End
   Begin VB.Label Label5 
      Caption         =   "DI high latch value(Hex)"
      Height          =   255
      Left            =   360
      TabIndex        =   6
      Top             =   2040
      Width           =   1815
   End
   Begin VB.Label Label4 
      Caption         =   "DI value(Hex)"
      Height          =   255
      Left            =   360
      TabIndex        =   5
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Step3:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Step2: Total channels"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Step1: Slot"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim hPort As Long

Private Sub cmdCleaDIrLatch_Click()
Dim slot As Long
Dim ret As Boolean
'Get slot
slot = cmbSlot.ListIndex + 1
'Open COM1
hPort = uart_Open("")
'Clear DI latch
ret = pac_ClearDILatch(hPort, slot)
If ret = False Then
    MsgBox "Clear DI latch", vbOKOnly, "Clear latch"
End If

txtHighLatch.Text = "0"
txtLowLatch.Text = "0"
'Close COM1
uart_Close (hPort)
End Sub

Private Sub cmdReadDI_Click()
Dim slot As Long
Dim DIValue As Long
Dim ret As Boolean
Dim HighLatchVal As Long
Dim LowLatchVal As Long
'Get slot
slot = cmbSlot.ListIndex + 1
'Open COM1
hPort = uart_Open("")
'Read DI value
ret = pac_ReadDI(hPort, slot, CLng(txtDIChs.Text), DIValue)
If ret = False Then
    MsgBox "Read DI fail", vbOKOnly, "Read DI"
Else
    txtDIValue.Text = Hex(DIValue)
End If
'Read DI high latch
ret = pac_ReadDILatch(hPort, slot, CLng(txtDIChs.Text), 1, HighLatchVal)
If ret = False Then
    MsgBox "Read DI high latch fail", vbOKOnly, "Read DI high latch"
Else
    txtHighLatch.Text = Hex(HighLatchVal)
End If
'Read DI low latch
ret = pac_ReadDILatch(hPort, slot, CLng(txtDIChs.Text), 0, LowLatchVal)
If ret = False Then
    MsgBox "Read DI low latch fail", vbOKOnly, "Read DI low latch"
Else
    txtLowLatch.Text = Hex(LowLatchVal)
End If
'Close COM1
uart_Close (hPort)
End Sub

Private Sub Form_Load()
cmbSlot.ListIndex = 0
End Sub
