VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "87K dio latch demo"
   ClientHeight    =   3540
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5490
   LinkTopic       =   "Form1"
   ScaleHeight     =   3540
   ScaleWidth      =   5490
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClearDIOLatch 
      Caption         =   "Clear DIO latch"
      Height          =   375
      Left            =   2640
      TabIndex        =   20
      Top             =   3000
      Width           =   2055
   End
   Begin VB.CommandButton cmdReadDIO 
      Caption         =   "Read DIO and latch"
      Height          =   375
      Left            =   360
      TabIndex        =   19
      Top             =   3000
      Width           =   2055
   End
   Begin VB.TextBox txtDOLowLatch 
      Height          =   285
      Left            =   4800
      TabIndex        =   18
      Text            =   "0"
      Top             =   2640
      Width           =   495
   End
   Begin VB.TextBox txtDOHighLatch 
      Height          =   285
      Left            =   4800
      TabIndex        =   17
      Text            =   "0"
      Top             =   2280
      Width           =   495
   End
   Begin VB.TextBox txtDILowLatch 
      Height          =   285
      Left            =   4800
      TabIndex        =   16
      Text            =   "0"
      Top             =   1920
      Width           =   495
   End
   Begin VB.TextBox txtDIHighLatch 
      Height          =   285
      Left            =   4800
      TabIndex        =   15
      Text            =   "0"
      Top             =   1560
      Width           =   495
   End
   Begin VB.TextBox txtDOValue 
      Height          =   285
      Left            =   2040
      TabIndex        =   10
      Text            =   "0"
      Top             =   1920
      Width           =   495
   End
   Begin VB.TextBox txtDIValue 
      Height          =   285
      Left            =   2040
      TabIndex        =   9
      Text            =   "0"
      Top             =   1560
      Width           =   495
   End
   Begin VB.TextBox txtDOChs 
      Height          =   285
      Left            =   2280
      TabIndex        =   5
      Text            =   "8"
      Top             =   960
      Width           =   375
   End
   Begin VB.TextBox txtDIChs 
      Height          =   285
      Left            =   2280
      TabIndex        =   4
      Text            =   "8"
      Top             =   600
      Width           =   375
   End
   Begin VB.ComboBox cmbSlot 
      Height          =   315
      ItemData        =   "i87K_dio_latch.frx":0000
      Left            =   1200
      List            =   "i87K_dio_latch.frx":0019
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label10 
      Caption         =   "DO low latch value(Hex)"
      Height          =   255
      Left            =   2760
      TabIndex        =   14
      Top             =   2640
      Width           =   1815
   End
   Begin VB.Label Label9 
      Caption         =   "DO high latch value(Hex)"
      Height          =   255
      Left            =   2760
      TabIndex        =   13
      Top             =   2280
      Width           =   1815
   End
   Begin VB.Label Label8 
      Caption         =   "DI low latch value(Hex)"
      Height          =   255
      Left            =   2760
      TabIndex        =   12
      Top             =   1920
      Width           =   1815
   End
   Begin VB.Label Label7 
      Caption         =   "DI high latch value(Hex)"
      Height          =   255
      Left            =   2760
      TabIndex        =   11
      Top             =   1560
      Width           =   1815
   End
   Begin VB.Label Label6 
      Caption         =   "DO value(Hex)"
      Height          =   255
      Left            =   840
      TabIndex        =   8
      Top             =   1920
      Width           =   1095
   End
   Begin VB.Label Label5 
      Caption         =   "DI value(Hex)"
      Height          =   255
      Left            =   840
      TabIndex        =   7
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Step3: "
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1440
      Width           =   495
   End
   Begin VB.Label Label3 
      Caption         =   "Total DO channels"
      Height          =   255
      Left            =   600
      TabIndex        =   3
      Top             =   960
      Width           =   1455
   End
   Begin VB.Label Label2 
      Caption         =   "Step2: Total DI channels "
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1935
   End
   Begin VB.Label Label1 
      Caption         =   "Step1: Slot"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim hPort As Long

Private Sub cmdClearDIOLatch_Click()
Dim slot As Long
Dim ret As Boolean
'Get slot
slot = cmbSlot.ListIndex + 1
'Open COM1
hPort = uart_Open("")
'Clear DIO latch
ret = pac_ClearDIOLatch(hPort, slot)
If ret = False Then
    MsgBox "Clear DIO latch values fail", vbOKOnly, "Clear DIO latch values"
End If
'Close COM1
uart_Close (hPort)
End Sub

Private Sub cmdReadDIO_Click()
Dim slot As Long
Dim ret As Boolean
Dim DOValue As Long
Dim DIValue As Long
Dim DILowLatchValue As Long
Dim DIHighLatchValue As Long
Dim DOLowLatchValue As Long
Dim DOHighLatchValue As Long
'Get slot
slot = cmbSlot.ListIndex + 1
'Open COM1
hPort = uart_Open("")
'Read DIO value
ret = pac_ReadDIO(hPort, slot, CLng(txtDIChs.Text), CLng(txtDOChs.Text), DIValue, DOValue)
If ret = False Then
    MsgBox "Read DIO values fail", vbOKOnly, "Read DIO values"
Else
    txtDIValue.Text = Hex(DIValue)
    txtDOValue.Text = Hex(DOValue)
End If
'Read DIO low latch
ret = pac_ReadDIOLatch(hPort, slot, CLng(txtDIChs.Text), CLng(txtDOChs.Text), 0, DILowLatchValue, DOLowLatchValue)
If ret = False Then
    MsgBox "Read DIO low latch fail", vbOKOnly, "Read DIO low latch"
Else
    txtDILowLatch.Text = Hex(DILowLatchValue)
    txtDOLowLatch.Text = Hex(DOLowLatchValue)
End If
'Read DIO high latch
ret = pac_ReadDIOLatch(hPort, slot, CLng(txtDIChs.Text), CLng(txtDOChs.Text), 1, DIHighLatchValue, DOHighLatchValue)
If ret = False Then
    MsgBox "Read DIO high latch fail", vbOKOnly, "Read DIO high latch"
Else
    txtDIHighLatch.Text = Hex(DIHighLatchValue)
    txtDOHighLatch.Text = Hex(DOHighLatchValue)
End If
'Close COM1
uart_Close (hPort)
End Sub

Private Sub Form_Load()
cmbSlot.ListIndex = 0
End Sub
