VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Memory demo"
   ClientHeight    =   3330
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4635
   LinkTopic       =   "Form1"
   ScaleHeight     =   3330
   ScaleWidth      =   4635
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtByteNum 
      Height          =   375
      Left            =   2400
      TabIndex        =   16
      Text            =   "5"
      Top             =   1680
      Width           =   495
   End
   Begin VB.CommandButton cmdRead 
      Caption         =   "Read"
      Height          =   375
      Left            =   1800
      TabIndex        =   12
      Top             =   2760
      Width           =   1095
   End
   Begin VB.TextBox txtRead 
      Height          =   375
      Left            =   120
      TabIndex        =   11
      Text            =   "0"
      Top             =   2760
      Width           =   1455
   End
   Begin VB.CommandButton cmdWrite 
      Caption         =   "Write"
      Height          =   375
      Left            =   1800
      TabIndex        =   10
      Top             =   2280
      Width           =   1095
   End
   Begin VB.TextBox txtWrite 
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Text            =   "Hello"
      Top             =   2280
      Width           =   1455
   End
   Begin VB.TextBox txtIndex 
      Height          =   375
      Left            =   1920
      TabIndex        =   7
      Text            =   "0"
      Top             =   1200
      Width           =   615
   End
   Begin VB.TextBox txtEepromSize 
      Height          =   375
      Left            =   3000
      TabIndex        =   5
      Text            =   "0"
      Top             =   720
      Width           =   855
   End
   Begin VB.TextBox txtBBSramSize 
      Height          =   375
      Left            =   3000
      TabIndex        =   4
      Text            =   "0"
      Top             =   120
      Width           =   855
   End
   Begin VB.OptionButton OpEeprom 
      Caption         =   "EEPROM"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1335
   End
   Begin VB.OptionButton OpBBSram 
      Caption         =   "Battery backup sram"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
   Begin VB.Label Label7 
      Caption         =   "The number of bytes to read:"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   1800
      Width           =   2055
   End
   Begin VB.Label Label6 
      Caption         =   "bytes"
      Height          =   255
      Left            =   3960
      TabIndex        =   14
      Top             =   720
      Width           =   495
   End
   Begin VB.Label Label5 
      Caption         =   "bytes"
      Height          =   255
      Left            =   3960
      TabIndex        =   13
      Top             =   120
      Width           =   495
   End
   Begin VB.Label Label4 
      Caption         =   "th byte"
      Height          =   255
      Left            =   2640
      TabIndex        =   8
      Top             =   1320
      Width           =   735
   End
   Begin VB.Label Label3 
      Caption         =   "Write / Read start from "
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Size:"
      Height          =   255
      Left            =   2280
      TabIndex        =   3
      Top             =   840
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Size:"
      Height          =   255
      Left            =   2280
      TabIndex        =   2
      Top             =   240
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim PAC_MEM_SRAM As Integer
Dim PAC_MEM_EEPROM As Integer
Dim mem_type As Integer

Private Sub cmdRead_Click()
Dim size As Long
Dim buf(63) As Byte
Dim ReadByteNum As Integer
Dim ret As Boolean
'Get memory size
size = pac_GetMemorySize(mem_type)
'Get start index of "read"
index = CLng(txtIndex.Text)
If index < 0 Then
    index = 0
End If
If index > size - 1 Then
    index = size - 1
End If

ReadByteNum = CInt(txtByteNum.Text)
'Read data from memory
ret = pac_ReadMemory(index, buf(0), ReadByteNum, mem_type)

If ret = False Then
    MsgBox "pac_ReadMemory fails", vbOKOnly, "Read memory"
Else
    txtRead.Text = StrConv(buf, vbUnicode)
End If
End Sub

Private Sub cmdWrite_Click()
Dim size As Long
Dim index As Long
Dim buf(0 To 63) As Byte
Dim ret As Boolean
Dim Length As Integer
Dim i As Long
'Read memory size
size = pac_GetMemorySize(mem_type)
'Get start index of "write"
index = CLng(txtIndex.Text)
If index < 0 Then
    index = 0
End If
If index > size - 1 Then
    index = size - 1
End If

If mem_type = PAC_MEM_EEPROM Then
    pac_EnableEEPROM (True)
End If

Length = Len(txtWrite.Text)
'convert string to byte array
For i = 0 To Length - 1
    buf(i) = CByte(Asc(Mid(txtWrite.Text, i + 1, 1)))
Next i
'Write data to memory
ret = pac_WriteMemory(index, buf(0), Len(txtWrite.Text), mem_type)

If mem_type = PAC_MEM_EEPROM Then
    pac_EnableEEPROM (False)
End If
If ret = False Then
    MsgBox "pac_WriteMemory returns false", vbOKOnly, "Write memory"
End If

End Sub

Private Sub Form_Load()
Dim MemSize As Long


PAC_MEM_SRAM = 0
PAC_MEM_EEPROM = 1
mem_type = 0
'Get B.B.SRAM size
MemSize = pac_GetMemorySize(PAC_MEM_SRAM)
txtBBSramSize.Text = CStr(MemSize)
'Get EEPROM size
MemSize = pac_GetMemorySize(PAC_MEM_EEPROM)
txtEepromSize.Text = CStr(MemSize)
End Sub

Private Sub OpBBSram_Click()
mem_type = PAC_MEM_SRAM
End Sub

Private Sub OpEeprom_Click()
mem_type = PAC_MEM_EEPROM
End Sub
