// 87K_diDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87K_di.h"
#include "87K_diDlg.h"
#include "pacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87K_diDlg dialog

CMy87K_diDlg::CMy87K_diDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87K_diDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87K_diDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87K_diDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87K_diDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87K_diDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87K_diDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ReadDI, OnReadDI)
	ON_BN_CLICKED(IDC_ReadDIMF, OnReadDIMF)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87K_diDlg message handlers

BOOL CMy87K_diDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//set default value
	SetDlgItemText(IDC_COMBOSlot,"1");
	SetDlgItemText(IDC_Chs,"16");

	SetDlgItemText(IDC_infor, "What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy87K_diDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy87K_diDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy87K_diDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMy87K_diDlg::OnReadDI() 
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it opens COM0 port and set baud rate to 115200 bps
	//COM0 port connects to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBOSlot,temp,20);
	int slot = atoi(temp);
	
	//get user set total channel
	GetDlgItemText(IDC_Chs,temp,20);
	int channel = atoi(temp);
	DWORD DIValue;

	//use pac_ReadAI functio to read DI data
	BOOL iret = pac_ReadDI(hPort,slot,channel,&DIValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,"Read data error","87K_di",MB_OK);
	}else{	
		wsprintf(temp,"0x%lx",DIValue);
		SetDlgItemText(IDC_DIValue,temp);
	}

}

void CMy87K_diDlg::OnReadDIMF() 
{
	// TODO: Add your control notification handler code here
	
	//uart_Open function parameter is "", it opens COM0 port and set baud rate to 115200
	//COM0 port connects to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBOSlot,temp,20);
	int slot = atoi(temp);
	
	//get total channels
	GetDlgItemText(IDC_Chs,temp,20);
	int channel = atoi(temp);
	DWORD DIValue;

	//use pac_ReadDI function to read DI data
	BOOL iret = pac_ReadDI_MF(hPort,slot,channel,&DIValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,"Read data error","87K_di",MB_OK);
	}else{	
		wsprintf(temp,"0x%lx",DIValue);
		SetDlgItemText(IDC_DIValue,temp);
	}
}
